gst: don't use volatile to mean atomic

volatile is not sufficient to provide atomic guarantees and real atomics
should be used instead.  GCC 11 has started warning about using volatile
with atomic operations.

https://gitlab.gnome.org/GNOME/glib/-/merge_requests/1719

Discovered in gstreamer/gst-plugins-good#868

Part-of: <gstreamer/gst-plugins-bad!2155>
29 jobs for !2155 with backport-mr-2098-into-1.18-gst-bad-drop-volatile in 80 minutes and 16 seconds (queued for 4 seconds)
merge request